/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of Int64.xs. Do not edit this file, edit Int64.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Int64.xs"
/* -*- Mode: C -*- */

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

static HV *capi_hash;

static int may_die_on_overflow;
static int may_use_native;

#ifdef __MINGW32__
#include <stdint.h>
#endif

#define NV_0x1p31 ((NV)2147483648)
#define NV_0x1p32 ((NV)4294967296)
#define NV_0x1p63 (NV_0x1p32 * NV_0x1p31)
#define NV_0x1p64 (NV_0x1p32 * NV_0x1p32)

#ifdef _MSC_VER
#include <stdlib.h>
typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;

#ifndef INT64_MAX
#define INT64_MAX _I64_MAX
#endif
#ifndef INT64_MIN
#define INT64_MIN _I64_MIN
#endif
#ifndef UINT64_MAX
#define UINT64_MAX _UI64_MAX
#endif
#ifndef UINT32_MAX
#define UINT32_MAX _UI32_MAX
#endif

#endif

#if ((defined _MSC_VER) || (defined INT64_MY_NV2U64))

/* Old MS compilers do not implement the double->uint64 conversion and
 * silently do a double->int64 conversion instead. See
 * http://connect.microsoft.com/VisualStudio/feedback/details/270762/error-in-converting-double-to-unsigned-long-long */

/* I don't trust atof, so I generate 2**-32 from simpler constants and
 * hope the optimizer will do its work properly */

#define NV_0x1p_4 ((NV)0.0625)
#define NV_0x1p_16 (NV_0x1p_4 * NV_0x1p_4 * NV_0x1p_4 * NV_0x1p_4)
#define NV_0x1p_32 (NV_0x1p_16 * NV_0x1p_16)

static uint64_t
nv2u64(NV nv) {
    if ((nv > 0.0) && (nv < NV_0x1p64)) {
        uint64_t h = nv * NV_0x1p_32;
        uint64_t l = nv - (NV)(int64_t)h * NV_0x1p32;
        return ((h << 32) + l);
    }
    return 0;
}
#define NV2U64(nv) nv2u64(nv)

static NV
u642nv(uint64_t u64) {
    unsigned long h = u64 >> 32;
    unsigned long l = u64 & 0xffffffff;
    return (NV_0x1p32 * h) + (NV)l;
}
# define U642NV(nv) u642nv(nv)

#else
#define NV2U64(nv) ((uint64_t)(nv))
#define U642NV(u64) ((NV)(u64))
#endif

#if (PERL_VERSION >= 10)

#ifndef cop_hints_fetch_pvs
#define cop_hints_fetch_pvs(cop, key, flags) \
    Perl_refcounted_he_fetch(aTHX_ (cop)->cop_hints_hash, NULL, STR_WITH_LEN(key), (flags), 0)
#endif

static int
check_die_on_overflow_hint(pTHX) {
    SV *hint = cop_hints_fetch_pvs(PL_curcop, "Math::Int64::die_on_overflow", 0);
    return (hint && SvTRUE(hint));
}

static int
check_use_native_hint(pTHX) {
    SV *hint = cop_hints_fetch_pvs(PL_curcop, "Math::Int64::native_if_available", 0);
    return (hint && SvTRUE(hint));
}

#define use_native (may_use_native && check_use_native_hint(aTHX))

#else

static int
check_die_on_overflow_hint(pTHX) {
    return 1;
}

static int
check_use_native_hint(pTHX) {
    return 1;
}

#define use_native may_use_native

#endif

static void
overflow(pTHX_ char *msg) {
    if (check_die_on_overflow_hint(aTHX))
        Perl_croak(aTHX_ "Math::Int64 overflow: %s", msg);
}

static char *out_of_bounds_error_s = "number is out of bounds for int64_t conversion";
static char *out_of_bounds_error_u = "number is out of bounds for uint64_t conversion";
static char *mul_error            = "multiplication overflows";
static char *add_error            = "addition overflows";
static char *sub_error            = "subtraction overflows";
static char *inc_error            = "increment operation wraps";
static char *dec_error            = "decrement operation wraps";
static char *left_b_error         = "left-shift right operand is out of bounds";
static char *left_error           = "left shift overflows";
static char *right_b_error        = "right-shift right operand is out of bounds";
static char *right_error          = "right shift overflows";

#include "strtoint64.h"
#include "isaac64.h"

#if defined(INT64_BACKEND_NV)
#  define BACKEND "NV"
#  define SvI64Y SvNVX
#  define SvI64_onY SvNOK_on
#  define SVt_I64 SVt_NV
#elif defined(INT64_BACKEND_IV)
#  define BACKEND "IV"
#  define SvI64Y SvIVX
#  define SvI64_onY SvIOK_on
#  define SVt_I64 SVt_IV
#else
#  error "unsupported backend"
#endif

static int
SvI64OK(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *si64 = SvRV(sv);
        return (si64 && (SvTYPE(si64) >= SVt_I64) && sv_isa(sv, "Math::Int64"));
    }
    return 0;
}

static int
SvU64OK(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *su64 = SvRV(sv);
        return (su64 && (SvTYPE(su64) >= SVt_I64) && sv_isa(sv, "Math::UInt64"));
    }
    return 0;
}

static SV *
newSVi64(pTHX_ int64_t i64) {
    SV *sv;
    SV *si64 = newSV(0);
    SvUPGRADE(si64, SVt_I64);
    *(int64_t*)(&(SvI64Y(si64))) = i64;
    SvI64_onY(si64);
    sv = newRV_noinc(si64);
    sv_bless(sv, gv_stashpvs("Math::Int64", TRUE));
    return sv;
}

static SV *
newSVu64(pTHX_ uint64_t u64) {
    SV *sv;
    SV *su64 = newSV(0);
    SvUPGRADE(su64, SVt_I64);
    *(int64_t*)(&(SvI64Y(su64))) = u64;
    SvI64_onY(su64);
    sv = newRV_noinc(su64);
    sv_bless(sv, gv_stashpvs("Math::UInt64", TRUE));
    return sv;
}

#define SvI64X(sv) (*(int64_t*)(&(SvI64Y(SvRV(sv)))))
#define SvU64X(sv) (*(uint64_t*)(&(SvI64Y(SvRV(sv)))))

static SV *
SvSI64(pTHX_ SV *sv) {
    if (SvRV(sv)) {
        SV *si64 = SvRV(sv);
        if (si64 && (SvTYPE(si64) >= SVt_I64))
            return si64;
    }
    Perl_croak(aTHX_ "internal error: reference to NV expected");
}

static SV *
SvSU64(pTHX_ SV *sv) {
    if (SvRV(sv)) {
        SV *su64 = SvRV(sv);
        if (su64 && (SvTYPE(su64) >= SVt_I64))
            return su64;
    }
    Perl_croak(aTHX_ "internal error: reference to NV expected");
}

#define SvI64x(sv) (*(int64_t*)(&(SvI64Y(SvSI64(aTHX_ sv)))))
#define SvU64x(sv) (*(uint64_t*)(&(SvI64Y(SvSU64(aTHX_ sv)))))

static int64_t
SvI64(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *si64 = SvRV(sv);
        if (si64 && SvOBJECT(si64)) {
            GV *method;
            HV *stash = SvSTASH(si64);
            char const * classname = HvNAME_get(stash);
            if (strncmp(classname, "Math::", 6) == 0) {
                int u;
                if (classname[6] == 'U') {
                    u = 1;
                    classname += 7;
                }
                else {
                    u = 0;
                    classname += 6;
                }
                if (strcmp(classname, "Int64") == 0) {
                    if (SvTYPE(si64) < SVt_I64)
                        Perl_croak(aTHX_ "Wrong internal representation for %s object", HvNAME_get(stash));
                    if (u) {
                        uint64_t u = *(uint64_t*)(&(SvI64Y(si64)));
                        if (may_die_on_overflow && (u > INT64_MAX)) overflow(aTHX_ out_of_bounds_error_s);
                        return u;
                    }
                    else {
                        return *(int64_t*)(&(SvI64Y(si64)));
                    }
                }
            }
            method = gv_fetchmethod(stash, "as_int64");
            if (method) {
                SV *result;
                int count;
                dSP;
                ENTER;
                SAVETMPS;
                PUSHSTACKi(PERLSI_MAGIC);
                PUSHMARK(SP);
                XPUSHs(sv);
                PUTBACK;
                count = perl_call_sv( (SV*)method, G_SCALAR );
                SPAGAIN;
                if (count != 1)
                    Perl_croak(aTHX_ "internal error: method call returned %d values, 1 expected", count);
                result = newSVsv(POPs);
                PUTBACK;
                POPSTACK;
                SPAGAIN;
                FREETMPS;
                LEAVE;
                return SvI64(aTHX_ sv_2mortal(result));
            }
        }
    }
    else {
        SvGETMAGIC(sv);
        if (SvIOK(sv)) {
            if (SvIOK_UV(sv)) {
                UV uv = SvUV(sv);
                if (may_die_on_overflow &&
                    (uv > INT64_MAX)) overflow(aTHX_ out_of_bounds_error_s);
                return uv;
            }
            return SvIV(sv);
        }
        if (SvNOK(sv)) {
            NV nv = SvNV(sv);
            if ( may_die_on_overflow &&
                 ((nv >= NV_0x1p63) || (nv < -NV_0x1p63)) ) overflow(aTHX_ out_of_bounds_error_s);
            return nv;
        }
    }
    return strtoint64(aTHX_ SvPV_nolen(sv), 10, 1);
}

static uint64_t
SvU64(pTHX_ SV *sv) {
    if (SvROK(sv)) {
        SV *su64 = SvRV(sv);
        if (su64 && SvOBJECT(su64)) {
            GV *method;
            HV *stash = SvSTASH(su64);
            char const * classname = HvNAME_get(stash);
            if (strncmp(classname, "Math::", 6) == 0) {
                int u;
                if (classname[6] == 'U') {
                    u = 1;
                    classname += 7;
                }
                else {
                    u = 0;
                    classname += 6;
                }
                if (strcmp(classname, "Int64") == 0) {
                    if (SvTYPE(su64) < SVt_I64)
                        Perl_croak(aTHX_ "Wrong internal representation for %s object", HvNAME_get(stash));
                    if (u) {
                        return *(uint64_t*)(&(SvI64Y(su64)));
                    }
                    else {
                        int64_t i = *(int64_t*)(&(SvI64Y(su64)));
                        if (may_die_on_overflow && (i < 0)) overflow(aTHX_ out_of_bounds_error_u);
                        return i;
                    }
                }
            }
            method = gv_fetchmethod(SvSTASH(su64), "as_uint64");
            if (method) {
                SV *result;
                int count;
                dSP;
                ENTER;
                SAVETMPS;
                PUSHSTACKi(PERLSI_MAGIC);
                PUSHMARK(SP);
                XPUSHs(sv);
                PUTBACK;
                count = perl_call_sv( (SV*)method, G_SCALAR );
                SPAGAIN;
                if (count != 1)
                    Perl_croak(aTHX_ "internal error: method call returned %d values, 1 expected", count);
                result = newSVsv(POPs);
                PUTBACK;
                POPSTACK;
                SPAGAIN;
                FREETMPS;
                LEAVE;
                return SvU64(aTHX_ sv_2mortal(result));
            }
        }
    }
    else {
        SvGETMAGIC(sv);
        if (SvIOK(sv)) {
            if (SvIOK_UV(sv)) {
                return SvUV(sv);
            }
            else {
                IV iv = SvIV(sv);
                if (may_die_on_overflow &&
                    (iv < 0) ) overflow(aTHX_ out_of_bounds_error_u);
                return SvIV(sv);
            }
        }
        if (SvNOK(sv)) {
            NV nv = SvNV(sv);
            if (may_die_on_overflow &&
                ( (nv < 0) || (nv >= NV_0x1p64)) ) overflow(aTHX_ out_of_bounds_error_u);
            return NV2U64(nv);
        }
    }
    return strtoint64(aTHX_ SvPV_nolen(sv), 10, 0);
}

static SV *
si64_to_number(pTHX_ SV *sv) {
    int64_t i64 = SvI64(aTHX_ sv);
    if (i64 < 0) {
        IV iv = i64;
        if (iv == i64)
            return newSViv(iv);
    }
    else {
        UV uv = i64;
        if (uv == i64)
            return newSVuv(uv);
    }
    return newSVnv(i64);
}

static SV *
su64_to_number(pTHX_ SV *sv) {
    uint64_t u64 = SvU64(aTHX_ sv);
    UV uv = u64;
    if (uv == u64)
        return newSVuv(uv);
    return newSVnv(U642NV(u64));
}

#define I64STRLEN 65

static SV *
u64_to_string_with_sign(pTHX_ uint64_t u64, int base, int sign) {
    char str[I64STRLEN];
    int len = 0;
    if ((base > 36) || (base < 2))
        Perl_croak(aTHX_ "base %d out of range [2,36]", base);
    while (u64) {
        char c = u64 % base;
        u64 /= base;
        str[len++] = c + (c > 9 ? 'A' - 10 : '0');
    }
    if (len) {
        int i;
        int svlen = len + (sign ? 1 : 0);
        SV *sv = newSV(svlen);
        char *pv = SvPVX(sv);
        SvPOK_on(sv);
        SvCUR_set(sv, svlen);
        if (sign) *(pv++) = '-';
        for (i = len; i--;) *(pv++) = str[i];
        return sv;
    }
    else {
        return newSVpvs("0");
    }
}

static SV *
i64_to_string(pTHX_ int64_t i64, int base) {
    if (i64 < 0) {    
        return u64_to_string_with_sign(aTHX_ -i64, base, 1);
    }
    return u64_to_string_with_sign(aTHX_ i64, base, 0);
}

#line 450 "Int64.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 592 "Int64.c"

XS_EUPXS(XS_Math__Int64__backend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__backend)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 459 "Int64.xs"
    RETVAL = BACKEND;
#line 605 "Int64.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__set_may_die_on_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__set_may_die_on_overflow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "v");
    {
	int	v = (int)SvIV(ST(0))
;
#line 467 "Int64.xs"
    may_die_on_overflow = v;
#line 623 "Int64.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int64__set_may_use_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__set_may_use_native)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "v");
    {
	int	v = (int)SvIV(ST(0))
;
#line 473 "Int64.xs"
    may_use_native = v;
#line 640 "Int64.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int64_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "value=&PL_sv_undef");
    {
	SV *	value;
	SV *	RETVAL;

	if (items < 1)
	    value = &PL_sv_undef;
	else {
	    value = ST(0)
;
	}
#line 479 "Int64.xs"
    RETVAL = (use_native
              ? newSViv(SvIV(value))
              : newSVi64(aTHX_ SvI64(aTHX_ value)));
#line 666 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "value=&PL_sv_undef");
    {
	SV *	value;
	SV *	RETVAL;

	if (items < 1)
	    value = &PL_sv_undef;
	else {
	    value = ST(0)
;
	}
#line 489 "Int64.xs"
    RETVAL = (use_native
              ? newSVuv(SvUV(value))
              : newSVu64(aTHX_ SvU64(aTHX_ value)));
#line 694 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_to_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_to_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 499 "Int64.xs"
    RETVAL = si64_to_number(aTHX_ self);
#line 714 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64_to_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64_to_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 507 "Int64.xs"
    RETVAL = su64_to_number(aTHX_ self);
#line 734 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_net_to_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_net_to_int64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	SV *	net = ST(0)
;
#line 515 "Int64.xs"
    STRLEN len;
    unsigned char *pv = (unsigned char *)SvPV(net, len);
    int64_t i64;
#line 755 "Int64.c"
	SV *	RETVAL;
#line 519 "Int64.xs"
    if (len != 8) Perl_croak(aTHX_ "Invalid length for int64");
    i64 = (((((((((((((((int64_t)pv[0]) << 8)
                      + (int64_t)pv[1]) << 8)
                    + (int64_t)pv[2]) << 8)
                  + (int64_t)pv[3]) << 8)
                + (int64_t)pv[4]) << 8)
              + (int64_t)pv[5]) << 8)
            + (int64_t)pv[6]) <<8)
        + (int64_t)pv[7];
    RETVAL = ( use_native
               ? newSViv(i64)
               : newSVi64(aTHX_ i64) );
#line 770 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_net_to_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_net_to_uint64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	SV *	net = ST(0)
;
#line 538 "Int64.xs"
    STRLEN len;
    unsigned char *pv = (unsigned char *)SvPV(net, len);
    uint64_t u64;
#line 791 "Int64.c"
	SV *	RETVAL;
#line 542 "Int64.xs"
    if (len != 8)
        Perl_croak(aTHX_ "Invalid length for uint64");
    u64 = (((((((((((((((uint64_t)pv[0]) << 8)
                      + (uint64_t)pv[1]) << 8)
                    + (uint64_t)pv[2]) << 8)
                  + (uint64_t)pv[3]) << 8)
                + (uint64_t)pv[4]) << 8)
              + (uint64_t)pv[5]) << 8)
            + (uint64_t)pv[6]) <<8)
        + (uint64_t)pv[7];
    RETVAL = ( use_native
               ? newSVuv(u64)
               : newSVu64(aTHX_ u64) );
#line 807 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_to_net); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_to_net)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 562 "Int64.xs"
    char *pv;
    int64_t i64 = SvI64(aTHX_ self);
    int i;
#line 828 "Int64.c"
	SV *	RETVAL;
#line 566 "Int64.xs"
    RETVAL = newSV(8);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, 8);
    pv = SvPVX(RETVAL);
    pv[8] = '\0';
    for (i = 7; i >= 0; i--, i64 >>= 8)
        pv[i] = i64;
#line 838 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64_to_net); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64_to_net)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 580 "Int64.xs"
    char *pv;
    uint64_t u64 = SvU64(aTHX_ self);
    int i;
#line 859 "Int64.c"
	SV *	RETVAL;
#line 584 "Int64.xs"
    RETVAL = newSV(8);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, 8);
    pv = SvPVX(RETVAL);
    pv[8] = '\0';
    for (i = 7; i >= 0; i--, u64 >>= 8)
        pv[i] = u64;
#line 869 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_native_to_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_native_to_int64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "native");
    {
	SV *	native = ST(0)
;
#line 598 "Int64.xs"
    STRLEN len;
    char *pv = SvPV(native, len);
#line 889 "Int64.c"
	SV *	RETVAL;
#line 601 "Int64.xs"
    if (len != 8)
        Perl_croak(aTHX_ "Invalid length for int64");
    if (use_native) {
        RETVAL = newSViv(0);
        Copy(pv, &(SvIVX(RETVAL)), 8, char);
    }
    else {
        RETVAL = newSVi64(aTHX_ 0);
        Copy(pv, &(SvI64X(RETVAL)), 8, char);
    }
#line 902 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_native_to_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_native_to_uint64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "native");
    {
	SV *	native = ST(0)
;
#line 618 "Int64.xs"
    STRLEN len;
    char *pv = SvPV(native, len);
#line 922 "Int64.c"
	SV *	RETVAL;
#line 621 "Int64.xs"
    if (len != 8)
        Perl_croak(aTHX_ "Invalid length for uint64");
    if (use_native) {
        RETVAL = newSVuv(0);
        Copy(pv, &(SvUVX(RETVAL)), 8, char);
    }
    else {
        RETVAL = newSVu64(aTHX_ 0);
        Copy(pv, &(SvU64X(RETVAL)), 8, char);
    }
#line 935 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_to_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_to_native)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 638 "Int64.xs"
    char *pv;
    int64_t i64 = SvI64(aTHX_ self);
#line 955 "Int64.c"
	SV *	RETVAL;
#line 641 "Int64.xs"
    RETVAL = newSV(9);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, 8);
    pv = SvPVX(RETVAL);
    Copy(&i64, pv, 8, char);
    pv[8] = '\0';
#line 964 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64_to_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64_to_native)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 654 "Int64.xs"
    char *pv;
    uint64_t u64 = SvU64(aTHX_ self);
#line 984 "Int64.c"
	SV *	RETVAL;
#line 657 "Int64.xs"
    RETVAL = newSV(9);
    SvPOK_on(RETVAL);
    SvCUR_set(RETVAL, 8);
    pv = SvPVX(RETVAL);
    Copy(&u64, pv, 8, char);
    pv[8] = '\0';
#line 993 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_to_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_to_string)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, base = 10");
    {
	SV *	self = ST(0)
;
	int	base;
	SV *	RETVAL;

	if (items < 2)
	    base = 10;
	else {
	    base = (int)SvIV(ST(1))
;
	}
#line 671 "Int64.xs"
    RETVAL = i64_to_string(aTHX_ SvI64(aTHX_ self), base);
#line 1021 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64_to_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64_to_string)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, base = 10");
    {
	SV *	self = ST(0)
;
	int	base;
	SV *	RETVAL;

	if (items < 2)
	    base = 10;
	else {
	    base = (int)SvIV(ST(1))
;
	}
#line 680 "Int64.xs"
    RETVAL = u64_to_string_with_sign(aTHX_ SvU64(aTHX_ self), base, 0);
#line 1049 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_to_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_to_hex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 688 "Int64.xs"
    RETVAL = i64_to_string(aTHX_ SvI64(aTHX_ self), 16);
#line 1069 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64_to_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64_to_hex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 696 "Int64.xs"
    RETVAL = u64_to_string_with_sign(aTHX_ SvU64(aTHX_ self), 16, 0);
#line 1089 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_string_to_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_string_to_int64)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "str, base = 0");
    {
	const char *	str = (const char *)SvPV_nolen(ST(0))
;
	int	base;
	SV *	RETVAL;

	if (items < 2)
	    base = 0;
	else {
	    base = (int)SvIV(ST(1))
;
	}
#line 705 "Int64.xs"
    RETVAL = ( use_native
               ? newSViv(strtoint64(aTHX_ str, base, 1))
               : newSVi64(aTHX_ strtoint64(aTHX_ str, base, 1)) );
#line 1119 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_string_to_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_string_to_uint64)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "str, base = 0");
    {
	const char *	str = (const char *)SvPV_nolen(ST(0))
;
	int	base;
	SV *	RETVAL;

	if (items < 2)
	    base = 0;
	else {
	    base = (int)SvIV(ST(1))
;
	}
#line 716 "Int64.xs"
    RETVAL = ( use_native
               ? newSVuv(strtoint64(aTHX_ str, base, 0))
               : newSVu64(aTHX_ strtoint64(aTHX_ str, base, 0)) );
#line 1149 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_hex_to_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_hex_to_int64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	const char *	str = (const char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 726 "Int64.xs"
    RETVAL = ( use_native
               ? newSViv(strtoint64(aTHX_ str, 16, 1))
               : newSVi64(aTHX_ strtoint64(aTHX_ str, 16, 1)) );
#line 1171 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_hex_to_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_hex_to_uint64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	const char *	str = (const char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 736 "Int64.xs"
    RETVAL = ( use_native
               ? newSVuv(strtoint64(aTHX_ str, 16, 0))
               : newSVu64(aTHX_ strtoint64(aTHX_ str, 16, 0)) );
#line 1193 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_rand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_rand)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 746 "Int64.xs"
    int64_t i64 = rand64();
#line 1210 "Int64.c"
	SV *	RETVAL;
#line 748 "Int64.xs"
    RETVAL = ( use_native
               ? newSViv(i64)
               : newSVi64(aTHX_ i64) );
#line 1216 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_uint64_rand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_uint64_rand)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 757 "Int64.xs"
    uint64_t u64 = rand64();
#line 1233 "Int64.c"
	SV *	RETVAL;
#line 759 "Int64.xs"
    RETVAL = ( use_native
               ? newSViv(u64)
               : newSVu64(aTHX_ u64) );
#line 1239 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64_int64_srand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64_int64_srand)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "seed=&PL_sv_undef");
    {
	SV *	seed;
#line 769 "Int64.xs"
#line 1256 "Int64.c"

	if (items < 1)
	    seed = &PL_sv_undef;
	else {
	    seed = ST(0)
;
	}
#line 770 "Int64.xs"
    if (SvOK(seed) && SvCUR(seed)) {
        STRLEN len;
        const char *pv = SvPV_const(seed, len);
        char *shadow = (char*)randrsl;
        int i;
        if (len > sizeof(randrsl)) len = sizeof(randrsl);
        Zero(shadow, sizeof(randrsl), char);
        Copy(pv, shadow, len, char);

        /* make the seed endianness agnostic */
        for (i = 0; i < RANDSIZ; i++) {
            char *p = shadow + i * sizeof(uint64_t);
            randrsl[i] = (((((((((((((((uint64_t)p[0]) << 8) + p[1]) << 8) + p[2]) << 8) + p[3]) << 8) +
                               p[4]) << 8) + p[5]) << 8) + p[6]) << 8) + p[7];
    }
        randinit(1);
    }
    else
        randinit(0);
#line 1284 "Int64.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Int64__inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__inc)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 799 "Int64.xs"
    if (may_die_on_overflow && (SvI64x(self) == INT64_MAX)) overflow(aTHX_ inc_error);
    SvI64x(self)++;
    RETVAL = self;
    SvREFCNT_inc(RETVAL);
#line 1307 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__dec)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 812 "Int64.xs"
    if (may_die_on_overflow && (SvI64x(self) == INT64_MIN)) overflow(aTHX_ dec_error);
    SvI64x(self)--;
    RETVAL = self;
    SvREFCNT_inc(RETVAL);
#line 1332 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__add)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 825 "Int64.xs"
    int64_t a = SvI64x(self);
    int64_t b = SvI64(aTHX_ other);
#line 1355 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 828 "Int64.xs"
    if ( may_die_on_overflow &&
         ( a > 0
           ? ( (b > 0) && (INT64_MAX - a < b) )
           : ( (b < 0) && (INT64_MIN - a > b) ) ) ) overflow(aTHX_ add_error);
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ a + b);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) = a + b;
    }
#line 1376 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__sub)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 848 "Int64.xs"
    int64_t a = SvI64x(self);
    int64_t b = SvI64(aTHX_ other);
#line 1399 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 851 "Int64.xs"
    if (SvTRUE(rev)) {
        int64_t tmp = a;
        a = b; b = tmp;
    }
    if ( may_die_on_overflow &&
         ( a > 0
           ? ( ( b < 0) && (a - INT64_MAX > b) )
           : ( ( b > 0) && (a - INT64_MIN < b) ) ) ) overflow(aTHX_ sub_error);
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ a - b);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) = a - b;
    }
#line 1424 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__mul)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 875 "Int64.xs"
    int64_t a1 = SvI64x(self);
    int64_t b1 = SvI64(aTHX_ other);
#line 1447 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 878 "Int64.xs"
    if (may_die_on_overflow) {
        int neg = 0;
        uint64_t a, b, rl, rh;
        if (a1 < 0) {
            a = -a1;
            neg ^= 1;
        }
        else a = a1;
        if (b1 < 0) {
            b = -b1;
            neg ^= 1;
        }
        else b = b1;
        if (a < b) {
            uint64_t tmp = a;
            a = b; b = tmp;
        }
        if (b > UINT32_MAX) overflow(aTHX_ mul_error);
        else {
            rl = (a & UINT32_MAX) * b;
            rh = (a >> 32) * b + (rl >> 32);
            if (rh > UINT32_MAX) overflow(aTHX_ mul_error);
        }
        if (a * b > (neg ? (~(uint64_t)INT64_MIN + 1) : INT64_MAX)) overflow(aTHX_ mul_error);
    }
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ a1 * b1);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) = a1 * b1;
    }
#line 1489 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__div)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 919 "Int64.xs"
    int64_t up;
    int64_t down;
#line 1512 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 922 "Int64.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvI64(aTHX_ other);
            down = SvI64x(self);
        }
        else {
            up = SvI64x(self);
            down = SvI64(aTHX_ other);
        }
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = newSVi64(aTHX_ up/down);
    }
    else {
        down = SvI64(aTHX_ other);
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) /= down;
    }
#line 1543 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__rest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__rest)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 952 "Int64.xs"
    int64_t up;
    int64_t down;
#line 1566 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 955 "Int64.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvI64(aTHX_ other);
            down = SvI64x(self);
        }
        else {
            up = SvI64x(self);
            down = SvI64(aTHX_ other);
        }
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = newSVi64(aTHX_ up % down);
    }
    else {
        down = SvI64(aTHX_ other);
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) %= down;
    }
#line 1597 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__left)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 984 "Int64.xs"
    int64_t a;
    uint64_t b;
#line 1620 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 987 "Int64.xs"
    if (SvTRUE(rev)) {
        a = SvI64(aTHX_ other);
        b = SvU64x(self);
    }
    else {
        a = SvI64x(self);
        b = SvU64(aTHX_ other);
    }
    if (may_die_on_overflow && (b > 64)) overflow(aTHX_ left_error);
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ (b > 64 ? 0 : (a << b)));
    else {
        RETVAL = SvREFCNT_inc(self);
        SvI64x(self) = (b > 64 ? 0 : (a << b));
    }
#line 1645 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__right)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1010 "Int64.xs"
    int64_t a;
    uint64_t b;
#line 1668 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1013 "Int64.xs"
    if (SvTRUE(rev)) {
        a = SvI64(aTHX_ other);
        b = SvU64x(self);
    }
    else {
        a = SvI64x(self);
        b = SvU64(aTHX_ other);
    }
    if (may_die_on_overflow && (b > 64)) overflow(aTHX_ right_error);
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ a >> b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvI64x(self) = (a >> b);
    }
#line 1693 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__spaceship)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1037 "Int64.xs"
    int64_t left;
    int64_t right;
#line 1716 "Int64.c"
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1040 "Int64.xs"
    if (SvTRUE(rev)) {
        left = SvI64(aTHX_ other);
        right = SvI64x(self);
    }
    else {
        left = SvI64x(self);
        right = SvI64(aTHX_ other);
    }
    RETVAL = (left < right ? -1 : left > right ? 1 : 0);
#line 1736 "Int64.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__eqn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__eqn)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;
#line 1058 "Int64.xs"
    RETVAL = ( SvI64x(self) == SvI64(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 1760 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__nen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__nen)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;
#line 1070 "Int64.xs"
    RETVAL = ( SvI64x(self) != SvI64(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 1785 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__gtn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__gtn)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1082 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvI64x(self) < SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI64x(self) > SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1818 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__ltn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__ltn)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1095 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvI64x(self) > SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI64x(self) < SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1851 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__gen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__gen)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1108 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvI64x(self) <= SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI64x(self) >= SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1884 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__len)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1121 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvI64x(self) >= SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvI64x(self) <= SvI64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 1917 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__and)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1134 "Int64.xs"
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ SvI64x(self) & SvI64(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) &= SvI64(aTHX_ other);
    }
#line 1953 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__or)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1150 "Int64.xs"
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ SvI64x(self) | SvI64(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) |= SvI64(aTHX_ other);
    }
#line 1989 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__xor)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1166 "Int64.xs"
    if (SvOK(rev))
        RETVAL = newSVi64(aTHX_ SvI64x(self) ^ SvI64(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvI64x(self) ^= SvI64(aTHX_ other);
    }
#line 2025 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__not)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1182 "Int64.xs"
    RETVAL = SvI64x(self) ? &PL_sv_no : &PL_sv_yes;
#line 2047 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__bnot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__bnot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1192 "Int64.xs"
    RETVAL = newSVi64(aTHX_ ~SvI64x(self));
#line 2069 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__neg)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1202 "Int64.xs"
    RETVAL = newSVi64(aTHX_ -SvI64x(self));
#line 2091 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__bool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__bool)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1212 "Int64.xs"
    RETVAL = SvI64x(self) ? &PL_sv_yes : &PL_sv_no;
#line 2113 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__number)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1222 "Int64.xs"
    RETVAL = si64_to_number(aTHX_ self);
#line 2135 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__clone)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1232 "Int64.xs"
    RETVAL = newSVi64(aTHX_ SvI64x(self));
#line 2157 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Int64__string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Int64__string)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1242 "Int64.xs"
    RETVAL = i64_to_string(aTHX_ SvI64x(self), 10);
#line 2179 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__inc)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1255 "Int64.xs"
    if (may_die_on_overflow && (SvU64x(self) == UINT64_MAX)) overflow(aTHX_ inc_error);
    SvU64x(self)++;
    RETVAL = SvREFCNT_inc(self);
#line 2203 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__dec)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1267 "Int64.xs"
    if (may_die_on_overflow && (SvU64x(self) == 0)) overflow(aTHX_ dec_error);
    SvU64x(self)--;
    RETVAL = SvREFCNT_inc(self);
#line 2227 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__add)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1279 "Int64.xs"
    uint64_t a, b;
#line 2249 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1281 "Int64.xs"
    a = SvU64x(self);
    b = SvU64(aTHX_ other);
    if (may_die_on_overflow && (UINT64_MAX - a < b)) overflow(aTHX_ add_error);
    if (SvOK(rev)) 
        RETVAL = newSVu64(aTHX_ a + b);
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU64x(self) = a + b;
    }
#line 2269 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__sub)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1300 "Int64.xs"
    uint64_t a, b;
#line 2291 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1302 "Int64.xs"
    if (SvTRUE(rev)) {
        a = SvU64(aTHX_ other);
        b = SvU64x(self);
    }
    else {
        a = SvU64x(self);
        b = SvU64(aTHX_ other);
    }
    if (may_die_on_overflow && (b > a)) overflow(aTHX_ sub_error);
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ a - b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvU64x(self) = a - b;
    }
#line 2316 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__mul)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1326 "Int64.xs"
    uint64_t a, b;
#line 2338 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1328 "Int64.xs"
    a = SvU64x(self);
    b = SvU64(aTHX_ other);
    if (may_die_on_overflow) {
        if (a < b) {
            uint64_t tmp = a;
            a = b; b = tmp;
        }
        if (b > UINT32_MAX) overflow(aTHX_ mul_error);
        else {
            uint64_t rl, rh;
            rl = (a & UINT32_MAX) * b;
            rh = (a >> 32) * b + (rl >> 32);
            if (rh > UINT32_MAX) overflow(aTHX_ mul_error);
        }
    }
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ a * b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvU64x(self) = a * b;
    }
#line 2369 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__div)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1358 "Int64.xs"
    uint64_t up, down;
#line 2391 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1360 "Int64.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvU64(aTHX_ other);
            down = SvU64x(self);
        }
        else {
            up = SvU64x(self);
            down = SvU64(aTHX_ other);
        }
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = newSVu64(aTHX_ up/down);
    }
    else {
        down = SvU64(aTHX_ other);
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU64x(self) /= down;
    }
#line 2422 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__rest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__rest)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1390 "Int64.xs"
    uint64_t up;
    uint64_t down;
#line 2445 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1393 "Int64.xs"
    if (SvOK(rev)) {
        if (SvTRUE(rev)) {
            up = SvU64(aTHX_ other);
            down = SvU64x(self);
        }
        else {
            up = SvU64x(self);
            down = SvU64(aTHX_ other);
        }
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = newSVu64(aTHX_ up % down);
    }
    else {
        down = SvU64(aTHX_ other);
        if (!down)
            Perl_croak(aTHX_ "Illegal division by zero");
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU64x(self) %= down;
    }
#line 2476 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__left)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1422 "Int64.xs"
    uint64_t a, b;
#line 2498 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1424 "Int64.xs"
    if (SvTRUE(rev)) {
        a = SvU64(aTHX_ other);
        b = SvU64x(self);
    }
    else {
        a = SvU64x(self);
        b = SvU64(aTHX_ other);
    }
    if (may_die_on_overflow && (b > 64)) overflow(aTHX_ left_b_error);
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ a << b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvU64x(self) = (a << b);
    }
#line 2523 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__right)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1447 "Int64.xs"
    uint64_t a, b;
#line 2545 "Int64.c"
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1449 "Int64.xs"
    if (SvTRUE(rev)) {
        a = SvU64(aTHX_ other);
        b = SvU64x(self);
    }
    else {
        a = SvU64x(self);
        b = SvU64(aTHX_ other);
    }
    if ( may_die_on_overflow && (b > 64)) overflow(aTHX_ right_b_error);
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ a >> b);
    else {
        RETVAL = SvREFCNT_inc(self);
        SvU64x(self) = (a >> b);
    }
#line 2570 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__spaceship)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
#line 1473 "Int64.xs"
    uint64_t left;
    uint64_t right;
#line 2593 "Int64.c"
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1476 "Int64.xs"
    if (SvTRUE(rev)) {
        left = SvU64(aTHX_ other);
        right = SvU64x(self);
    }
    else {
        left = SvU64x(self);
        right = SvU64(aTHX_ other);
    }
    RETVAL = (left < right ? -1 : left > right ? 1 : 0);
#line 2613 "Int64.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__eqn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__eqn)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;
#line 1494 "Int64.xs"
    RETVAL = ( SvU64x(self) == SvU64(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 2637 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__nen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__nen)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;
#line 1506 "Int64.xs"
    RETVAL = ( SvU64x(self) != SvU64(aTHX_ other)
               ? &PL_sv_yes
               : &PL_sv_no );
#line 2662 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__gtn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__gtn)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1518 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvU64x(self) < SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU64x(self) > SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2695 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__ltn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__ltn)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1531 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvU64x(self) > SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU64x(self) < SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2728 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__gen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__gen)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1544 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvU64x(self) <= SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU64x(self) >= SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2761 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__len)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1557 "Int64.xs"
    if (SvTRUE(rev))
        RETVAL = SvU64x(self) >= SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
    else
        RETVAL = SvU64x(self) <= SvU64(aTHX_ other) ? &PL_sv_yes : &PL_sv_no;
#line 2794 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__and)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1570 "Int64.xs"
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ SvU64x(self) & SvU64(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU64x(self) &= SvU64(aTHX_ other);
    }
#line 2830 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__or)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1586 "Int64.xs"
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ SvU64x(self) | SvU64(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU64x(self) |= SvU64(aTHX_ other);
    }
#line 2866 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__xor)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, rev = &PL_sv_no");
    {
	SV *	self = ST(0)
;
	SV *	other = ST(1)
;
	SV *	rev;
	SV *	RETVAL;

	if (items < 3)
	    rev = &PL_sv_no;
	else {
	    rev = ST(2)
;
	}
#line 1602 "Int64.xs"
    if (SvOK(rev))
        RETVAL = newSVu64(aTHX_ SvU64x(self) ^ SvU64(aTHX_ other));
    else {
        RETVAL = self;
        SvREFCNT_inc(RETVAL);
        SvU64x(self) ^= SvU64(aTHX_ other);
    }
#line 2902 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__not)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1618 "Int64.xs"
    RETVAL = SvU64x(self) ? &PL_sv_no : &PL_sv_yes;
#line 2924 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__bnot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__bnot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1628 "Int64.xs"
    RETVAL = newSVu64(aTHX_ ~SvU64x(self));
#line 2946 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__neg)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1638 "Int64.xs"
    RETVAL = newSVu64(aTHX_ ~(SvU64x(self)-1));
#line 2968 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__bool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__bool)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1648 "Int64.xs"
    RETVAL = SvU64x(self) ? &PL_sv_yes : &PL_sv_no;
#line 2990 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__number)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1658 "Int64.xs"
    RETVAL = su64_to_number(aTHX_ self);
#line 3012 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__clone)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1668 "Int64.xs"
    RETVAL = newSVu64(aTHX_ SvU64x(self));
#line 3034 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__UInt64__string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__UInt64__string)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, other = NULL, rev = NULL");
    {
	SV *	self = ST(0)
;
	SV *	other;
	SV *	rev;
	SV *	RETVAL;
#line 1678 "Int64.xs"
    RETVAL = u64_to_string_with_sign(aTHX_ SvU64x(self), 10, 0);
#line 3056 "Int64.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__Int64); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Int64)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Math::Int64::_backend", XS_Math__Int64__backend, file);
        newXS("Math::Int64::_set_may_die_on_overflow", XS_Math__Int64__set_may_die_on_overflow, file);
        newXS("Math::Int64::_set_may_use_native", XS_Math__Int64__set_may_use_native, file);
        newXS("Math::Int64::int64", XS_Math__Int64_int64, file);
        newXS("Math::Int64::uint64", XS_Math__Int64_uint64, file);
        newXS("Math::Int64::int64_to_number", XS_Math__Int64_int64_to_number, file);
        newXS("Math::Int64::uint64_to_number", XS_Math__Int64_uint64_to_number, file);
        newXS("Math::Int64::net_to_int64", XS_Math__Int64_net_to_int64, file);
        newXS("Math::Int64::net_to_uint64", XS_Math__Int64_net_to_uint64, file);
        newXS("Math::Int64::int64_to_net", XS_Math__Int64_int64_to_net, file);
        newXS("Math::Int64::uint64_to_net", XS_Math__Int64_uint64_to_net, file);
        newXS("Math::Int64::native_to_int64", XS_Math__Int64_native_to_int64, file);
        newXS("Math::Int64::native_to_uint64", XS_Math__Int64_native_to_uint64, file);
        newXS("Math::Int64::int64_to_native", XS_Math__Int64_int64_to_native, file);
        newXS("Math::Int64::uint64_to_native", XS_Math__Int64_uint64_to_native, file);
        newXS("Math::Int64::int64_to_string", XS_Math__Int64_int64_to_string, file);
        newXS("Math::Int64::uint64_to_string", XS_Math__Int64_uint64_to_string, file);
        newXS("Math::Int64::int64_to_hex", XS_Math__Int64_int64_to_hex, file);
        newXS("Math::Int64::uint64_to_hex", XS_Math__Int64_uint64_to_hex, file);
        newXS("Math::Int64::string_to_int64", XS_Math__Int64_string_to_int64, file);
        newXS("Math::Int64::string_to_uint64", XS_Math__Int64_string_to_uint64, file);
        newXS("Math::Int64::hex_to_int64", XS_Math__Int64_hex_to_int64, file);
        newXS("Math::Int64::hex_to_uint64", XS_Math__Int64_hex_to_uint64, file);
        newXS("Math::Int64::int64_rand", XS_Math__Int64_int64_rand, file);
        newXS("Math::Int64::uint64_rand", XS_Math__Int64_uint64_rand, file);
        newXS("Math::Int64::int64_srand", XS_Math__Int64_int64_srand, file);
        newXS("Math::Int64::_inc", XS_Math__Int64__inc, file);
        newXS("Math::Int64::_dec", XS_Math__Int64__dec, file);
        newXS("Math::Int64::_add", XS_Math__Int64__add, file);
        newXS("Math::Int64::_sub", XS_Math__Int64__sub, file);
        newXS("Math::Int64::_mul", XS_Math__Int64__mul, file);
        newXS("Math::Int64::_div", XS_Math__Int64__div, file);
        newXS("Math::Int64::_rest", XS_Math__Int64__rest, file);
        newXS("Math::Int64::_left", XS_Math__Int64__left, file);
        newXS("Math::Int64::_right", XS_Math__Int64__right, file);
        newXS("Math::Int64::_spaceship", XS_Math__Int64__spaceship, file);
        newXS("Math::Int64::_eqn", XS_Math__Int64__eqn, file);
        newXS("Math::Int64::_nen", XS_Math__Int64__nen, file);
        newXS("Math::Int64::_gtn", XS_Math__Int64__gtn, file);
        newXS("Math::Int64::_ltn", XS_Math__Int64__ltn, file);
        newXS("Math::Int64::_gen", XS_Math__Int64__gen, file);
        newXS("Math::Int64::_len", XS_Math__Int64__len, file);
        newXS("Math::Int64::_and", XS_Math__Int64__and, file);
        newXS("Math::Int64::_or", XS_Math__Int64__or, file);
        newXS("Math::Int64::_xor", XS_Math__Int64__xor, file);
        newXS("Math::Int64::_not", XS_Math__Int64__not, file);
        newXS("Math::Int64::_bnot", XS_Math__Int64__bnot, file);
        newXS("Math::Int64::_neg", XS_Math__Int64__neg, file);
        newXS("Math::Int64::_bool", XS_Math__Int64__bool, file);
        newXS("Math::Int64::_number", XS_Math__Int64__number, file);
        newXS("Math::Int64::_clone", XS_Math__Int64__clone, file);
        newXS("Math::Int64::_string", XS_Math__Int64__string, file);
        newXS("Math::UInt64::_inc", XS_Math__UInt64__inc, file);
        newXS("Math::UInt64::_dec", XS_Math__UInt64__dec, file);
        newXS("Math::UInt64::_add", XS_Math__UInt64__add, file);
        newXS("Math::UInt64::_sub", XS_Math__UInt64__sub, file);
        newXS("Math::UInt64::_mul", XS_Math__UInt64__mul, file);
        newXS("Math::UInt64::_div", XS_Math__UInt64__div, file);
        newXS("Math::UInt64::_rest", XS_Math__UInt64__rest, file);
        newXS("Math::UInt64::_left", XS_Math__UInt64__left, file);
        newXS("Math::UInt64::_right", XS_Math__UInt64__right, file);
        newXS("Math::UInt64::_spaceship", XS_Math__UInt64__spaceship, file);
        newXS("Math::UInt64::_eqn", XS_Math__UInt64__eqn, file);
        newXS("Math::UInt64::_nen", XS_Math__UInt64__nen, file);
        newXS("Math::UInt64::_gtn", XS_Math__UInt64__gtn, file);
        newXS("Math::UInt64::_ltn", XS_Math__UInt64__ltn, file);
        newXS("Math::UInt64::_gen", XS_Math__UInt64__gen, file);
        newXS("Math::UInt64::_len", XS_Math__UInt64__len, file);
        newXS("Math::UInt64::_and", XS_Math__UInt64__and, file);
        newXS("Math::UInt64::_or", XS_Math__UInt64__or, file);
        newXS("Math::UInt64::_xor", XS_Math__UInt64__xor, file);
        newXS("Math::UInt64::_not", XS_Math__UInt64__not, file);
        newXS("Math::UInt64::_bnot", XS_Math__UInt64__bnot, file);
        newXS("Math::UInt64::_neg", XS_Math__UInt64__neg, file);
        newXS("Math::UInt64::_bool", XS_Math__UInt64__bool, file);
        newXS("Math::UInt64::_number", XS_Math__UInt64__number, file);
        newXS("Math::UInt64::_clone", XS_Math__UInt64__clone, file);
        newXS("Math::UInt64::_string", XS_Math__UInt64__string, file);

    /* Initialisation Section */

#line 444 "Int64.xs"
    may_die_on_overflow = 0;
    may_use_native = 0;
    capi_hash = get_hv("Math::Int64::C_API", TRUE|GV_ADDMULTI);
    hv_stores(capi_hash, "version", newSViv(1));
    hv_stores(capi_hash, "newSVi64", newSViv(PTR2IV(&newSVi64)));
    hv_stores(capi_hash, "newSVu64", newSViv(PTR2IV(&newSVu64)));
    hv_stores(capi_hash, "SvI64", newSViv(PTR2IV(&SvI64)));
    hv_stores(capi_hash, "SvU64", newSViv(PTR2IV(&SvU64)));
    hv_stores(capi_hash, "SvI64OK", newSViv(PTR2IV(&SvI64OK)));
    hv_stores(capi_hash, "SvU64OK", newSViv(PTR2IV(&SvU64OK)));
    randinit(0);

#line 3177 "Int64.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

